#include "hotplug.h"

int main(int argc, char *argv[])
{
    int iRet = 0;
    char sAction[256];
    char sDev[256];
    char sDir[256];
    char sCommand[256];
    char *pTmp;
    mode_t perms = 0777;
    struct stat s;
    FILE *fs;
    int bLog = 0;
    char sLog[256];
    
    if (argc >= 2) {
        // log debug messages if /var/hotplug exists
	if (stat("/var/hotplug", &s) == 0) {
	    bLog = 1;
	    sLog[0] = '\0';
	    sprintf(sLog, "ARG: %s\n", argv[1]);
	}

	if (strcasecmp(argv[1], "BLOCK")==0) {
	    pTmp = getenv("ACTION");
	    if ((pTmp != NULL) && (strcmp(pTmp, "") != 0)) {
		strcpy(sAction, pTmp);

		// fill log string
		if (bLog == 1) {
		    sprintf(sLog, "%sACTION: %s\n", sLog, sAction);
		}
		
		// ACTION ADD
		if (strcasecmp(sAction, "add") == 0) {
		    pTmp = getenv("DEVPATH");
		    if ((pTmp != NULL) && (strcmp(pTmp, "") != 0)) {

			strcpy(sDev, pTmp);

			// print log
			if (bLog == 1) {
			    sprintf(sLog, "%sDEV: %s\n", sLog, sDev);
			    if ((fs=fopen("/var/hotplug","a")) != NULL) {
				fprintf(fs, "%s", sLog);
			    }
			}

			if ((sDev[strlen(sDev)-1] >= '0') &&
			    (sDev[strlen(sDev)-1] <= '9')) {
			    
			    pTmp = strrchr(sDev, '/') + 1;
			    sprintf(sDev, "/dev/%s", pTmp);
			    sprintf(sDir, "%s/%s", MOUNTDIR, pTmp);
			    //printf("%s\n", sDev);

			    mkdir(MOUNTDIR, perms);
			    mkdir(sDir, perms);
			    sprintf(sCommand, "%s %s %s", MOUNT, sDev, sDir);
			    system(sCommand);

			    // Testing semaphore for multiple partitions
			    FILE *fs;
			    if ((fs=fopen(SMBSEMFILE,"r")) == NULL) {

				// Creating semaphore for multiple partitions
				fs=fopen(SMBSEMFILE,"w");
				fclose(fs);

				killSamba();
				sleep(5);

				remove(VARSMBCONF);
				sprintf(sCommand, "cp %s %s",
				    ETCSMBCONFDEF, VARSMBCONF);
				system(sCommand);			    
				configureSamba();
			    
				sprintf(sCommand, "%s -D", SMBD);
				system(sCommand);
				sprintf(sCommand, "%s -D", NMBD);
				system(sCommand);
				
				// Remove semaphore
				remove(SMBSEMFILE);
			    } else {
    				fclose(fs);
			    }
			}
		    } else {
			iRet = -3;
		    }

		// ACTION REMOVE
		} else if (strcasecmp(sAction, "remove") == 0) {
		    pTmp = getenv("DEVPATH");
		    if ((pTmp != NULL) && (strcmp(pTmp, "") != 0)) {
			strcpy(sDev, pTmp);

			// print log
			if (bLog == 1) {
			    sprintf(sLog, "%sDEV: %s\n", sLog, sDev);
			    if ((fs=fopen("/var/hotplug","a")) != NULL) {
				fprintf(fs, "%s", sLog);
			    }
			}

			if ((sDev[strlen(sDev)-1] >= '0') &&
			    (sDev[strlen(sDev)-1] <= '9')) {
			    
			    pTmp = strrchr(sDev, '/') + 1;
			    sprintf(sDev, "/dev/%s", pTmp);
			    sprintf(sDir, "%s/%s", MOUNTDIR, pTmp);
			    //printf("%s\n", sDev);

			    killSamba();
			    sprintf(sCommand, "%s %s", UMOUNT, sDev);
			    system(sCommand);
			    rmdir(sDir);
			}
		    } else {
			iRet = -3;
		    }
		}
	    } else {
		iRet = -2;
	    }
	}
	sprintf(sCommand, "%s %s", ORIGINALHOTPLUG, argv[1]);
	system(sCommand);	

    } else {
	sprintf(sCommand, "%s", ORIGINALHOTPLUG);
	system(sCommand);	
	iRet = -1;
    }

    return iRet;
}

int configureSamba()
{
    int iRet=0;
    FILE *fs;
    char sMDev[64], sMPoint[64];
    char s1[64], s2[64], s3[64], s4[64];
    char *pTmp;
    char strUpdateSmbConf[MAX_SMB_UPDATE_SIZE];

    strUpdateSmbConf[0]='\0';

    if ((fs=fopen("/proc/mounts","r")) != NULL) {
        while (fscanf(fs, "%s%s%s%s%s%s", sMDev, sMPoint, s1, s2, s3, s4) != EOF) {
	    //printf ("%s %s\n", sMDev, sMPoint);
	    if (strncmp(sMPoint, "/var/mounts", 11) == 0) {
		pTmp = strrchr(sMPoint, '/') + 1;
		sprintf(strUpdateSmbConf, "%s[%s]\n", strUpdateSmbConf, pTmp);
		sprintf(strUpdateSmbConf, "%spath = %s\npublic = yes\nwritable = yes\nprintable = no\nguest ok = yes\n\n",
		    strUpdateSmbConf, sMPoint);
	    }
	}
	fclose(fs);
    } else {
	iRet = -1;
    }
		    
    if (appendToTextFile(ETCSMBCONF, strUpdateSmbConf) < 0)
	iRet=-2;
	
    return iRet;
}

int appendToTextFile(char *strFilename, char *strPrint) {
    FILE *ftextconf = NULL;
    int iRet=0;

    ftextconf = fopen(strFilename, "a");

    if ( ftextconf == NULL ) {
	iRet=-1;
    } else {
	fprintf(ftextconf, strPrint);
	fclose(ftextconf);
	iRet=0;
    }
    
    return iRet;
}

int killSamba()
{
    FILE *fs;
    int smbPid;
    int nmbPid;
    char sTmp[64];
    int counter;
    
    sprintf(sTmp, "%s/smbd.pid", PIDDIR);
    if ((fs=fopen(sTmp,"r")) != NULL) {
	fscanf(fs, "%d", &smbPid);
	fclose(fs);
	kill(smbPid, SIGTERM);
	counter = 0;
	while (counter++ < 5) {
	    if (waitpid(smbPid, NULL, WNOHANG) > 0)
		break;
	    sleep(1);
	}
	if (waitpid(smbPid, NULL, WNOHANG) == 0) {
	    kill(smbPid, SIGKILL);
	}	
    }
    sprintf(sTmp, "%s/nmbd.pid", PIDDIR);
    if ((fs=fopen(sTmp,"r")) != NULL) {
	fscanf(fs, "%d", &nmbPid);
	fclose(fs);
	kill(nmbPid, SIGTERM);
	counter = 0;
	while (counter++ < 5) {
	    if (waitpid(nmbPid, NULL, WNOHANG) > 0)
		break;
	    sleep(1);
	}
	if (waitpid(nmbPid, NULL, WNOHANG) == 0) {
	    kill(nmbPid, SIGKILL);
	}	
    }
    
    return 0;
}
